SystemOrganization addCategory: #'SWE-IssueTracker'!

Object subclass: #ITImageDB
	instanceVariableNames: ''
	classVariableNames: 'ISSUES NEXTID'
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITImageDB class methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:11'!
connect

	^ self new.! !

!ITImageDB methodsFor: 'Issues' stamp: 'afk 11/12/2007 16:27'!
addIssue: anIssue

	anIssue id: NEXTID.
	ISSUES at: anIssue id put: anIssue.
	NEXTID := NEXTID+1.
	
	^ anIssue! !

!ITImageDB methodsFor: 'Issues' stamp: 'mfp 11/18/2007 16:21'!
getIssues
	^ ISSUES! !

!ITImageDB methodsFor: 'initialize-release' stamp: 'afk 11/12/2007 16:25'!
initialize

	ISSUES ifNil: [ISSUES := Dictionary new].
	NEXTID ifNil: [NEXTID := 0].
	super initialize.! !

Object subclass: #ITIssue
	instanceVariableNames: 'id tags comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssue methodsFor: 'changing' stamp: 'afk 11/12/2007 16:04'!
addComment: aComment
	
	comments add: aComment.! !

!ITIssue methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:55'!
comments
	^comments.! !

!ITIssue methodsFor: 'accessing' stamp: 'mfp 11/18/2007 16:41'!
getTag: tag
	^ tags at: tag ifAbsent: [^ nil].! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 16:20'!
id
	^ id! !

!ITIssue methodsFor: 'changing' stamp: 'afk 11/12/2007 16:20'!
id: anObject
	id := anObject! !

!ITIssue methodsFor: 'initialize-release' stamp: 'afk 11/12/2007 16:22'!
initialize
	
	tags := Dictionary new.
	comments := OrderedCollection new.
	super initialize.! !

!ITIssue methodsFor: 'changing' stamp: 'afk 11/12/2007 16:01'!
setTag: aTag to: aValue
	
	tags at: aTag put: aValue. ! !

Object subclass: #ITIssueManager
	instanceVariableNames: 'database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueManager methodsFor: 'changing' stamp: 'afk 11/12/2007 16:33'!
addIssueWithTitle: aTitle

	| anIssue |
	
	anIssue := ITIssue new.
	anIssue setTag: 'title' to: aTitle.
			
	^ database addIssue: anIssue. ! !

!ITIssueManager methodsFor: 'changing' stamp: 'afk 11/12/2007 16:30'!
addIssueWithTitle: aTitle withComment: aComment

	| anIssue |
	
	anIssue := ITIssue new.
	anIssue setTag: 'title' to: aTitle;
			addComment: aComment.
			
	^ database addIssue: anIssue. ! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mfp 11/18/2007 16:52'!
getIssues
	^ database getIssues.! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:34'!
getUrlFromIssue: anIssue
! !

!ITIssueManager methodsFor: 'initialize-release' stamp: 'afk 11/12/2007 16:22'!
initialize
	
	database := ITImageDB connect.
	super initialize.! !

WAComponent subclass: #ITComponentAddIssue
	instanceVariableNames: 'title initialComment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
initialComment
	^ initialComment! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
initialComment: anObject
	initialComment := anObject! !

!ITComponentAddIssue methodsFor: 'rendering' stamp: 'mt 11/23/2007 19:15'!
renderContentOn: html
	html heading 
		level: 1;
		with: 'Add Issue'.
	html form: 
		[
		html text: 'Title'.
			html break.
		html textInput on: #title of: self.
			html break.
		html text: 'Description'.
			html break.
		html textArea on: #initialComment of: self.
			html break.
		html submitButton 
			callback: [ITIssueManager new addIssueWithTitle: self title withComment: self initialComment. self answer. ];
			value: 'add Issue'.
		html cancelButton
			callback: [self answer];
			value: 'cancel'.
		]! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
title
	^ title! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
title: anObject
	title := anObject! !

WAComponent subclass: #ITComponentDetails
	instanceVariableNames: 'issue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentDetails class methodsFor: 'as yet unclassified' stamp: 'mt 11/23/2007 20:02'!
initializeWith: anIssue
	|view|
	view := self new.
	view issue: anIssue.
	^view.! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:47'!
issue
	^ issue! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:47'!
issue: anObject
	issue := anObject! !

!ITComponentDetails methodsFor: 'rendering' stamp: 'mt 11/23/2007 20:07'!
renderContentOn: html
	html heading
		level: 2;
		with: 'detailed view of an issue'.
	html div
		with: [
			html text: self issue id.
			html break.
			html text: (self issue getTag: 'title').
			
			html break; break.
			html table: [
				(self issue comments) do: [:comment|
					html tableRow: [ html tableData: [ html text: comment ] ]
				]
			].
			html anchor
				callback: [self answer];
				with: [html text: 'return to list'].
		]
					
				! !

WAComponent subclass: #ITComponentListIssues
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentListIssues methodsFor: 'rendering' stamp: 'mt 11/23/2007 19:49'!
renderContentOn: html
	| issues |
	issues := (ITIssueManager new) getIssues.
	html heading 
		level: 2;
		with: 'List all issues'.
	html form:[
		html table:[
			html tableRow: [
				html tableData: 'id'.
				html tableData: 'title'.
				html tableData: 'details'.
				].
			issues do: [:issue|
				html tableRow: [
					html tableData: (issue id asString).
					html tableData: (issue getTag: 'title').
					html tableData: [
						html anchor 
							callback: [self call: (ITComponentDetails initializeWith: issue)];
							with: [html text: 'detailed view'].
						]
					].
				].
			].
		]! !

WAComponent subclass: #ITComponentMenu
	instanceVariableNames: 'listIssues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentMenu class methodsFor: 'as yet unclassified' stamp: 'mt 11/23/2007 18:52'!
canBeRoot
	^true.! !

!ITComponentMenu methodsFor: 'initialize' stamp: 'mt 11/23/2007 19:05'!
children
	^Array with: self listIssues.! !

!ITComponentMenu methodsFor: 'initialize' stamp: 'mt 11/23/2007 19:05'!
initialize
	super initialize.
	self listIssues: ITComponentListIssues new.! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:05'!
listIssues
	^ listIssues! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:05'!
listIssues: anObject
	listIssues := anObject! !

!ITComponentMenu methodsFor: 'rendering' stamp: 'mt 11/23/2007 19:51'!
renderContentOn: html
	html heading
		level: 1;
		with: 'IssueTracker'.
	html anchor 
		callback: [ self call: ITComponentAddIssue new ]; 
		with: [ html text: 'add issue'].
	html div
		with: self listIssues.! !

TestCase subclass: #ITIssueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

TestCase subclass: #ITTestImageDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestImageDB methodsFor: 'testing' stamp: 'afk 11/12/2007 16:27'!
testAddIssue

	| newIssue db returningIssue |
	newIssue := ITIssue new.
	db := ITImageDB connect.
	returningIssue := db addIssue: newIssue.
	
	self assert: ( returningIssue isKindOf: ITIssue ) description: 'Returning Object is not kind of ITIssue'.
	self assert: ( returningIssue id notNil ) description: 'Returning ID is nil'.! !

TestCase subclass: #ITTestIssueManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestIssueManager methodsFor: 'testing' stamp: 'afk 11/12/2007 16:33'!
testAddIssue
	
	| IssueManager returningIssue |
	IssueManager := ITIssueManager new.
	
	returningIssue := IssueManager addIssueWithTitle: 'A Test Issue'.
	self assert: (returningIssue isKindOf: ITIssue) description: 'addIssue is not returning an Issue object'.
	! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mfp 11/18/2007 17:23'!
testGetIssues
	
	| issueManager |
	issueManager := ITIssueManager new.
	
	issueManager getIssues do: [:issue|
		self assert: (issue isKindOf: ITIssue) description: 'not all returning objects are issues'].
	
	
	! !
